%option no_sysinit
%zeropage basicsafe
%import textio
%import keyboard
%import diskio
%import sprites
%import compression

;lzsa.exe -f1 -r -m5 <input> <output>

main {

    sub start() {

        txt.clear_screen()

        keyboard.init()
        
        cx16.VERA_DC_HSCALE = $40
        cx16.VERA_DC_VSCALE = $40

        diskio.vload_raw("0.pal",1,$FA00 + 16*2)

        diskio.load_raw("0.lza", (0 * $300) + $2000)
        diskio.load_raw("1.lza", (1 * $300) + $2000)
        diskio.load_raw("2.lza", (2 * $300) + $2000)
        diskio.load_raw("3.lza", (3 * $300) + $2000)
        diskio.load_raw("4.lza", (4 * $300) + $2000)
        diskio.load_raw("5.lza", (5 * $300) + $2000)
        diskio.load_raw("6.lza", (6 * $300) + $2000)
        diskio.load_raw("7.lza", (7 * $300) + $2000)

        compression.decompress($2000, $4000,0)

        sprites.init(0,0,0,3,3,0,1)
        sprites.pos(0,-64,10)

        sprites.init(1,0,0,3,3,0,1)
        sprites.pos(1,10,85)

        sprites.init(2,0,0,3,3,0,1)
        sprites.pos(2,85,85)
        sprites.flipx(2, true)

        repeat 
        {
            if keyboard.pressed($6E) break
            sys.waitvsync()
            animate()
        }

        keyboard.deinit()

        cx16.VERA_DC_HSCALE = $80
        cx16.VERA_DC_VSCALE = $80

        sprites.hide(0)
        sprites.hide(1)
        sprites.hide(2)

    }

    ubyte frame = 0
    ubyte speed = 5
    word pos = -64

    sub animate()
    {
        move()

        speed--
        if speed != 0 return

        speed = 5

        frame++
        if frame >= 8 frame = 0

        compression.decompress((frame * $300) + $2000, $4000,0)
    }

    sub move()
    {
        pos += 3
        sprites.pos(0,pos,10)
        if pos > 320 pos = -64
    }
}

